#include "stdafx.h"
#include "endpointwrap.h"

using namespace System::Runtime::InteropServices;

namespace AudRecordCLI
{
	EndpointList^ Endpoints::Get()
	{
		EndpointList^ pList = nullptr;
		WinType<::EndpointArray*, void> pEndpoints(NULL, &FreeAudioEndpoints);
		HRESULT hr = GetAudioEndpoints(&pEndpoints);
		if(SUCCEEDED(hr))
		{
			DWORD numPoints = (*pEndpoints)->num;
			pList = gcnew EndpointList(numPoints);
			::Endpoint* pIter = (*pEndpoints)->outputs, *pEnd = pIter + numPoints;
			while(pIter != pEnd)
			{
				Endpoint^ pNewEndpoint = gcnew Endpoint();
				pNewEndpoint->Name = gcnew String(pIter->pName);
				IntPtr interfacePtr = IntPtr(pIter->pEndPoint);
				pNewEndpoint->Interface = Marshal::GetObjectForIUnknown(interfacePtr);
				pList->Add(pNewEndpoint);
				++pIter;
			}
		}
		return pList;
	}
}
