#ifndef STDAFX_H
#define STDAFX_H

#pragma once

#define _WIN32_WINNT 0x0600
#define NOMINMAX
#define WIN32_LEAN_AND_MEAN

#include <simpleassert.h>
#include <windows.h>
#include <windowsx.h>
#include <objbase.h>
#include <commctrl.h>
#include <cstdio>
#include "../scoped.h"

#include <new>
#include <string>
#include <vector>

#define WINDOW(id) GetDlgItem(hDlg, id)

inline std::wstring GetModuleString(HMODULE hMod, DWORD id)
{
	LPCWSTR pString = NULL;
	int len = LoadString(hMod, id, (LPWSTR)&pString, 0);
	return std::wstring(pString, len);
}

#define LOG_TEXT(string, ...) \
	do \
	{ \
		C_ASSERT(sizeof(*string) == sizeof(char)); \
		char buffer[300]; \
		_snprintf_s(buffer, ARRAYSIZE(buffer), __FUNCTION__  " " string "\n", __VA_ARGS__); \
		OutputDebugStringA(buffer); \
	} \
	while(0)

#endif
