﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using AudRecordCLI;

namespace AudRecordTestCLI
{
    class AudRecordData
    {
        public Recorder RecordObj { get; private set; }
        public List<Endpoint> Mixers { get; private set; }
        public List<Codec> Codecs { get; private set; }

        public AudRecordData()
        {
            Mixers = Endpoints.Get();
            Codecs = AudRecordCLI.Codecs.Get();
            RecordObj = null;
        }

        public List<CodecConfig> GetCodecConfigs(int index)
        {
            Debug.Assert(Codecs.Count > index, "Index out of range");
            Codec codec = Codecs[index];
            return codec.Configs;
        }

        public CodecConfig GetCodecConfig(int codecIndex, int configIndex)
        {
            List<CodecConfig> configs = GetCodecConfigs(codecIndex);
            Debug.Assert(configs.Count > configIndex);
            return configs[configIndex];
        }

        public Recorder CreateRecorder(CodecConfig config)
        {
            return RecordObj = Recorder.Create(config);
        }

        public void Record(int index)
        {
            RecordObj.Record(Mixers[index]);
        }
    }
}