/** \file wmfunctions.h
	\brief Declares functions that interact with the Windows Media SDK
	\cond DEV
*/

#ifndef AUDRECORD_WMFUNCTIONS_H
#define AUDRECORD_WMFUNCTIONS_H

#pragma once

#include <mmreg.h>
#include "exports.h"

HRESULT GetCodecAndProfileDescriptions(CodecConfigs*& pConfigs);
void FreeCodecAndProfileDescriptions(CodecConfigs* pConfigs);
HRESULT MatchCodecInputFormat(IWMWriter *pWriter, const WAVEFORMATEX& sourceFormat, WAVEFORMATEX& codecFormat);
HRESULT CreateAudRecordObject(CodecConfiguration* pCodecConfig, IAudRecord** ppAudRecord);

/** \endcond */

#endif
